#include <Python.h>
#include <stdlib.h>

#include <isl/constraint.h>
#include <isl/set.h>

struct _isl_constraint_list {
    int cursor;
    PyObject *constraints;
};
typedef struct _isl_constraint_list _isl_constraint_list;

int _isl_isl_basic_set_add_constraint_list(__isl_take isl_constraint *c,
        void *user) {
    _isl_constraint_list *list;

    list = (_isl_constraint_list *) user;
    return PyList_SetItem(list->constraints, list->cursor++,
        PyLong_FromVoidPtr(c));
}

static PyObject * _isl_isl_basic_set_constraints(PyObject *self,
        PyObject* args) {
    long ptr;
    isl_basic_set *bset;
    int n;
    PyObject *constraints;
    _isl_constraint_list *list;

    if (!PyArg_ParseTuple(args, "l", &ptr))
        return NULL;
    bset = (isl_basic_set*) ptr;
    n = isl_basic_set_n_constraint(bset);
    constraints = PyList_New(n);
    list = malloc(sizeof(_isl_constraint_list));
    list->cursor = 0;
    list->constraints = constraints;
    isl_basic_set_foreach_constraint(bset,
        _isl_isl_basic_set_add_constraint_list, list);
    free(list);
    return constraints;
}

static PyMethodDef _isl_methods[] = {
    {"isl_basic_set_constraints", _isl_isl_basic_set_constraints, METH_VARARGS, NULL},
    {NULL, NULL, 0, NULL}
};

static struct PyModuleDef _islmodule = {
    PyModuleDef_HEAD_INIT,
    "_isl",
    NULL,
    -1,
    _isl_methods
};

PyMODINIT_FUNC PyInit__isl(void) {
    PyObject *m;
    m = PyModule_Create(&_islmodule);
    if (m == NULL)
        return NULL;

    PyModule_AddObject(m, "isl_dim_set", PyLong_FromLong(isl_dim_set));

    return m;
}
